unit exUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure Memo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddToMemo(const Textline : string);
  end;

var
  Form1: TForm1;

implementation

uses TestProcs, zlib;

{$R *.DFM}
procedure TForm1.AddToMemo(const Textline : string);
begin
  Memo1.Lines.Add(Textline);
end;

procedure TForm1.Memo1Click(Sender: TObject);
var
  libver : PChar;
  TestFileName1 : string;
  TestFileName2 : string;
begin
  Memo1.Clear;
  Application.ProcessMessages;

  GcomprLen := 10000 * sizeof(integer);
  GuncomprLen := GcomprLen;
  libver := zlibVersion;
  if (libver[0] <> ZLIB_VERSION[0]) then
  begin
    AddToMemo('incompatible zlib version');
    exit;
  end else
    if (strcomp(zlibVersion, ZLIB_VERSION) <> 0) then
       AddToMemo('warning: different zlib version');

  Gcompr := StrAlloc(GcomprLen);
  Guncompr := StrAlloc(GuncomprLen);

  try
    {/* compr and uncompr are cleared to avoid reading uninitialized
     * data and to ensure that uncompr compresses well.
     */}
    FillChar(Gcompr^, GcomprLen, #0);
    FillChar(Guncompr^, GuncomprLen, #0);

    test_compress(Gcompr, GcomprLen, Guncompr, GuncomprLen);

    TestFileName1 := 'foo.gz' + #0;
    TestFileName2 := 'foo.gz' + #0;
    if ParamCount > 1 then TestFileName1 := Paramstr(1) + #0;
    if ParamCount > 2 then TestFileName2 := Paramstr(2) + #0;
    test_gzio(@TestFileName1[1], @TestFileName2[1], Guncompr, GuncomprLen);

    test_deflate(Gcompr, GcomprLen);
    test_inflate(Gcompr, GcomprLen, Guncompr, GuncomprLen);

    test_large_deflate(Gcompr, GcomprLen, Guncompr, GuncomprLen);
    test_large_inflate(Gcompr, GcomprLen, Guncompr, GuncomprLen);

    test_flush(Gcompr, GcomprLen);
    test_sync(Gcompr, GcomprLen, Guncompr, GuncomprLen);

    test_dict_deflate(Gcompr, GcomprLen);
    test_dict_inflate(Gcompr, GcomprLen, Guncompr, GuncomprLen);
    
    AddToMemo('__ done __');
  finally
    StrDispose(Gcompr);
    StrDispose(Guncompr);
  end;
end;

end.
