unit u1ComprTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComprClasses, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Memo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Memo1Click(Sender: TObject);
var
  MemoryStream: TMemoryStream;
  MemoryStream2: TMemoryStream;
  CStrings1: TComprStrings;
  CStrings2: TComprStrings;
  ComprStream: TComprMemStream;
begin
  MemoryStream := TMemoryStream.Create;
  MemoryStream2 := TMemoryStream.Create;
  ComprStream := TComprMemStream.Create(zLevelDefault);
  CStrings1 := TComprStrings.Create(zLevelDefault);
  CStrings2 := TComprStrings.Create(zLevelDefault);
  try
    Memo1.Lines.LoadFromFile('c:\windows\win.ini'); //load and display test data
    CStrings1.Assign(Memo1.Lines);                //fill strings object
    CStrings1.ComprToStream(MemoryStream);        //compress to a stream
    CStrings1.ComprToFile(Format('%swin.inz',     //compress to a file
                [ExtractFilePath(ParamStr(0))]));
    MemoryStream.Seek(0,0);                       //reset stream
    CStrings2.DecomprFromStream(MemoryStream);    //decompress from a stream
    Memo2.Lines.Assign(CStrings2);                //show results

    ShowMessage('Decompressing from file...');
    Memo2.Lines.Clear;
    CStrings2.Clear;
    Application.ProcessMessages;
    CStrings2.DecomprFromFile(Format('%swin.inz', //decompress from a file
                     [ExtractFilePath(ParamStr(0))]));
    Memo2.Lines.Assign(CStrings2);                //display test data
    Application.ProcessMessages;

    ShowMessage('Testing compression stream');

    Memo2.Lines.Clear;
    Application.ProcessMessages;

    Memo1.Lines.LoadFromFile('c:\windows\system.ini');
    Memo1.Lines.SaveToStream(ComprStream);       // fill stream object
    ComprStream.ComprToStream(MemoryStream2);    // compress to a stream
    MemoryStream2.Seek(0,0);                     // reset stream
    CStrings1.Clear;                             // reset strings object
    CStrings1.DecomprFromStream(MemoryStream2);  // decompress from a stream
    MemoryStream2.Seek(0,0);
    ComprStream.DecomprFromStream(MemoryStream2);// test decompress
    Memo2.Lines.Assign(CStrings1);               // show results
    Application.ProcessMessages;
    ShowMessage('Decompressed from stream');
    ComprStream.Seek(0,0);
    Memo2.Lines.LoadFromStream(ComprStream);

  finally
    MemoryStream.Free;
    MemoryStream2.Free;
    CStrings1.Free;
    CStrings2.Free;
    ComprStream.Free;
  end;
end;

end.
