unit u1DBCompr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBTables;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses u2DBComprDM, ComprClasses;

{$R *.DFM}

const
  DemoFileName = 'c:\windows\clouds.bmp';
  DataFileName = 'c:\program files\borland\delphi 2.0\demos\data\animals.dbt';

function SizeOfFile(const FName : string): Longint;
var
  f: file of Byte;
begin
  AssignFile(f, FName);
  try
    Reset(f);
    Result := FileSize(f);
  finally
    CloseFile(f);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  BitMap : TBitmap;
begin
  BitMap := TBitMap.Create;
  try
    BitMap.LoadFromFile(DemoFileName);
    with DataModule2 do
    begin
      Table1.Active := true;
      Table1.Append;
      Table1BMP.Assign(BitMap);
      Table1.Post;
    end;
    Label5.Caption := Format('Data file size is now %d bytes.', [SizeOfFile(DataFileName)]);
    Application.ProcessMessages;
  finally
    BitMap.Free;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  ComprData : TComprMemStream;
  BlobStream : TBlobStream;
begin
  with DataModule2 do
  begin
    ComprData := TComprMemStream.Create(zLevelDefault);
    Table1.Active := true;
    Table1.Append;
    BlobStream := TBlobStream.Create(Table1BMP, bmReadWrite);
    try
      ComprData.LoadFromFile(DemoFileName);
      ComprData.ComprToStream(BlobStream);
      Table1.Post;
    finally
      ComprData.Free;
      BlobStream.Free;
    end;
    Label6.Caption := Format('Data file size is now %d bytes.', [SizeOfFile(DataFileName)]);
    Application.ProcessMessages;
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label4.Caption := Format('Data file size started at %d',[SizeOfFile(DataFileName)]);;
  Label5.Caption := '';
  Label6.Caption := '';
end;

end.
